//-----------------------------------------------------------------------------
//
//	Musepack Demuxer
//
//	Author : Igor Janos
//
//-----------------------------------------------------------------------------
#pragma once

class CMPCReader;


//-----------------------------------------------------------------------------
//
//	CMPCFile class
//
//-----------------------------------------------------------------------------

class CMPCFile
{
public:

	// stream header
	__int64			duration_10mhz;			// total file duration
	int				stream_version;			// 7, 8 are supported
	int				sample_rate;
	int				channels;
	int				audio_block_frames;

	// replay gain
	float			gain_title_db;
	float			gain_title_peak_db;
	float			gain_album_db;
	float			gain_album_peak_db;

	// internals
	CMPCReader		*reader;				// file reader interface

	// packet parsing
	int				key;					// key for current packet
	uint8			*packet;				// packet payload
	int				packet_max_size;		// maximum allowed packet size
	int				packet_size;			// size of currently loaded payload
	
public:
	CMPCFile();
	virtual ~CMPCFile();

	// I/O for MPC file
	int Open(CMPCReader *reader);
	int ReadNextPacket();

	// parsing packets
	int ReadStreamHeader();
	int ReadReplaygain();

};
